package dev.shadowsoffire.apotheosis.ench;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import dev.shadowsoffire.apotheosis.Apoth;
import dev.shadowsoffire.apotheosis.ench.Ench;
import dev.shadowsoffire.apotheosis.ench.library.EnchLibraryBlock;
import dev.shadowsoffire.apotheosis.ench.objects.FilteringShelfBlock;
import dev.shadowsoffire.apotheosis.ench.objects.TreasureShelfBlock;
import dev.shadowsoffire.apotheosis.ench.objects.TypedShelfBlock;
import java.util.function.Supplier;
import net.minecraft.core.particles.ParticleOptions;
import net.minecraft.core.particles.ParticleTypes;
import net.minecraft.world.level.block.Block;
import net.minecraft.world.level.block.SoundType;
import net.minecraft.world.level.block.entity.BlockEntityType;
import net.minecraft.world.level.block.state.BlockBehaviour;
import net.minecraft.world.level.material.MapColor;
import net.minecraftforge.registries.RegistryObject;

public final class Blocks {
  public static final RegistryObject<Block> BEESHELF = woodShelf("beeshelf", MapColor.f_283832_, 0.75F, () -> ParticleTypes.f_123809_);
  
  public static final RegistryObject<Block> BLAZING_HELLSHELF = stoneShelf("blazing_hellshelf", MapColor.f_283927_, 1.5F, (Supplier<? extends ParticleOptions>)Apoth.Particles.ENCHANT_FIRE);
  
  public static final RegistryObject<Block> CRYSTAL_SEASHELF = stoneShelf("crystal_seashelf", MapColor.f_283772_, 1.5F, (Supplier<? extends ParticleOptions>)Apoth.Particles.ENCHANT_WATER);
  
  public static final RegistryObject<Block> DEEPSHELF = stoneShelf("deepshelf", MapColor.f_283927_, 2.5F, (Supplier<? extends ParticleOptions>)Apoth.Particles.ENCHANT_SCULK);
  
  public static final RegistryObject<Block> DORMANT_DEEPSHELF = stoneShelf("dormant_deepshelf", MapColor.f_283927_, 2.5F, (Supplier<? extends ParticleOptions>)Apoth.Particles.ENCHANT_SCULK);
  
  public static final RegistryObject<Block> DRACONIC_ENDSHELF = stoneShelf("draconic_endshelf", MapColor.f_283761_, 5.0F, (Supplier<? extends ParticleOptions>)Apoth.Particles.ENCHANT_END);
  
  public static final RegistryObject<Block> ECHOING_DEEPSHELF = stoneShelf("echoing_deepshelf", MapColor.f_283927_, 2.5F, (Supplier<? extends ParticleOptions>)Apoth.Particles.ENCHANT_SCULK);
  
  public static final RegistryObject<Block> ECHOING_SCULKSHELF = sculkShelf("echoing_sculkshelf");
  
  public static final RegistryObject<EnchLibraryBlock> ENDER_LIBRARY = Ench.R.block("ender_library", () -> new EnchLibraryBlock(dev.shadowsoffire.apotheosis.ench.library.EnchLibraryTile.EnderLibraryTile::new, 31));
  
  public static final RegistryObject<Block> ENDSHELF = stoneShelf("endshelf", MapColor.f_283761_, 4.5F, (Supplier<? extends ParticleOptions>)Apoth.Particles.ENCHANT_END);
  
  public static final RegistryObject<Block> GLOWING_HELLSHELF = stoneShelf("glowing_hellshelf", MapColor.f_283927_, 1.5F, (Supplier<? extends ParticleOptions>)Apoth.Particles.ENCHANT_FIRE);
  
  public static final RegistryObject<Block> HEART_SEASHELF = stoneShelf("heart_seashelf", MapColor.f_283772_, 1.5F, (Supplier<? extends ParticleOptions>)Apoth.Particles.ENCHANT_WATER);
  
  public static final RegistryObject<Block> HELLSHELF = stoneShelf("hellshelf", MapColor.f_283927_, 1.5F, (Supplier<? extends ParticleOptions>)Apoth.Particles.ENCHANT_FIRE);
  
  public static final RegistryObject<Block> INFUSED_HELLSHELF = stoneShelf("infused_hellshelf", MapColor.f_283927_, 1.5F, (Supplier<? extends ParticleOptions>)Apoth.Particles.ENCHANT_FIRE);
  
  public static final RegistryObject<Block> INFUSED_SEASHELF = stoneShelf("infused_seashelf", MapColor.f_283772_, 1.5F, (Supplier<? extends ParticleOptions>)Apoth.Particles.ENCHANT_WATER);
  
  public static final RegistryObject<EnchLibraryBlock> LIBRARY = Ench.R.block("library", () -> new EnchLibraryBlock(dev.shadowsoffire.apotheosis.ench.library.EnchLibraryTile.BasicLibraryTile::new, 16));
  
  public static final RegistryObject<Block> MELONSHELF = woodShelf("melonshelf", MapColor.f_283784_, 0.75F, () -> ParticleTypes.f_123809_);
  
  public static final RegistryObject<Block> PEARL_ENDSHELF = stoneShelf("pearl_endshelf", MapColor.f_283761_, 4.5F, (Supplier<? extends ParticleOptions>)Apoth.Particles.ENCHANT_END);
  
  public static final RegistryObject<Block> RECTIFIER = stoneShelf("rectifier", MapColor.f_283772_, 1.5F, (Supplier<? extends ParticleOptions>)Apoth.Particles.ENCHANT_WATER);
  
  public static final RegistryObject<Block> RECTIFIER_T2 = stoneShelf("rectifier_t2", MapColor.f_283927_, 1.5F, (Supplier<? extends ParticleOptions>)Apoth.Particles.ENCHANT_FIRE);
  
  public static final RegistryObject<Block> RECTIFIER_T3 = stoneShelf("rectifier_t3", MapColor.f_283761_, 1.5F, (Supplier<? extends ParticleOptions>)Apoth.Particles.ENCHANT_END);
  
  public static final RegistryObject<Block> SEASHELF = stoneShelf("seashelf", MapColor.f_283772_, 1.5F, (Supplier<? extends ParticleOptions>)Apoth.Particles.ENCHANT_WATER);
  
  public static final RegistryObject<Block> SIGHTSHELF = stoneShelf("sightshelf", MapColor.f_283927_, 1.5F, (Supplier<? extends ParticleOptions>)Apoth.Particles.ENCHANT_FIRE);
  
  public static final RegistryObject<Block> SIGHTSHELF_T2 = stoneShelf("sightshelf_t2", MapColor.f_283927_, 1.5F, (Supplier<? extends ParticleOptions>)Apoth.Particles.ENCHANT_FIRE);
  
  public static final RegistryObject<Block> SOUL_TOUCHED_DEEPSHELF = stoneShelf("soul_touched_deepshelf", MapColor.f_283927_, 2.5F, (Supplier<? extends ParticleOptions>)Apoth.Particles.ENCHANT_SCULK);
  
  public static final RegistryObject<Block> SOUL_TOUCHED_SCULKSHELF = sculkShelf("soul_touched_sculkshelf");
  
  public static final RegistryObject<Block> STONESHELF = stoneShelf("stoneshelf", MapColor.f_283947_, 1.75F, () -> ParticleTypes.f_123809_);
  
  public static final RegistryObject<Block> FILTERING_SHELF = Ench.R.block("filtering_shelf", () -> new FilteringShelfBlock(BlockBehaviour.Properties.m_284310_().m_284180_(MapColor.f_283772_).m_60918_(SoundType.f_56742_).m_60978_(1.75F).m_60999_()));
  
  public static final RegistryObject<Block> TREASURE_SHELF = Ench.R.block("treasure_shelf", () -> new TreasureShelfBlock(BlockBehaviour.Properties.m_284310_().m_284180_(MapColor.f_283927_).m_60918_(SoundType.f_56742_).m_60978_(1.75F).m_60999_()));
  
  private static void bootstrap() {}
  
  private static RegistryObject<Block> sculkShelf(String id) {
    return Ench.R.block(id, () -> new TypedShelfBlock.SculkShelfBlock(BlockBehaviour.Properties.m_284310_().m_284180_(MapColor.f_283927_).m_60918_(SoundType.f_56742_).m_60977_().m_60999_().m_60978_(3.5F), (Supplier)Apoth.Particles.ENCHANT_SCULK));
  }
  
  private static RegistryObject<Block> stoneShelf(String id, MapColor color, float strength, Supplier<? extends ParticleOptions> particle) {
    return Ench.R.block(id, () -> new TypedShelfBlock(BlockBehaviour.Properties.m_284310_().m_60999_().m_60918_(SoundType.f_56742_).m_284180_(color).m_60978_(strength), particle));
  }
  
  private static RegistryObject<Block> woodShelf(String id, MapColor color, float strength, Supplier<? extends ParticleOptions> particle) {
    return Ench.R.block(id, () -> new TypedShelfBlock(BlockBehaviour.Properties.m_284310_().m_60918_(SoundType.f_56736_).m_284180_(color).m_60978_(strength), particle));
  }
}
